﻿using System;
using System.Runtime.Serialization.Json;
using System.Runtime.Serialization;
using System.IO;
using System.Text;
using System.Windows;

namespace Sudoku
{
    public struct Coordinate
    {
        public int x;
        public int y;
    }

    public class TBlock
    {
        public Coordinate[] field;
    }

   
    [Serializable]
    public class TSettings
    {
        [DataMember]
        public bool freeform;

        [DataMember]
        public TBlock[] block;

        public TSettings()
        {
            int i;
            block = new TBlock[9];
            for (i = 0; i < 9; i++)
            {
                block[i] = new TBlock();
                block[i].field = new Coordinate[9];
            }
        }
    }

    class Settings
    {
        public TSettings parameter = new TSettings();
       
        public void writeJsonData(string FileName)
        {
            MemoryStream ms = new MemoryStream();
            DataContractJsonSerializer par = new DataContractJsonSerializer(typeof(TSettings));
            par.WriteObject(ms, parameter);
            using (FileStream fs = new FileStream(FileName, FileMode.Create))
            {
                ms.Position = 0;
                fs.Write(ms.ToArray(), 0, ms.ToArray().Length);
                ms.Close();
                fs.Close();
            }
        }

        public bool readJsonData(string FileName)
        {
            try
            {
                using (StreamReader r = new StreamReader(FileName))
                {
                    string JsonText = r.ReadToEnd();
                    MemoryStream m = new MemoryStream(Encoding.UTF8.GetBytes(JsonText));
                    DataContractJsonSerializer ser = new DataContractJsonSerializer(typeof(TSettings));
                    parameter = ser.ReadObject(m) as TSettings;
                }
                return true;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message);
                return false;
            }
        }

        internal void writeJsonData(object p)
        {
            throw new NotImplementedException();
        }
    }
}
